base-files: add sysupgrade -u to skip unchanged files
[openwrt/openwrt.git] / package / base-files / files / sbin / sysupgrade
index 93f0749108ec7ae5c3d8f77c84a3cb95bf8a5ff6..d4bb7a164fe3b139e8a6481011990cab1ffbc40a 100755 (executable)
@@ -1,16 +1,16 @@
 #!/bin/sh
+
 . /lib/functions.sh
 . /lib/functions/system.sh
 
 # initialize defaults
-RAMFS_COPY_BIN=""      # extra programs for temporary ramfs root
-RAMFS_COPY_DATA=""     # extra data files
 export MTD_CONFIG_ARGS=""
 export INTERACTIVE=0
 export VERBOSE=1
 export SAVE_CONFIG=1
 export SAVE_OVERLAY=0
-export DELAY=
+export SAVE_PARTITIONS=1
+export SKIP_UNCHANGED=0
 export CONF_IMAGE=
 export CONF_BACKUP_LIST=0
 export CONF_BACKUP=
@@ -24,20 +24,21 @@ export TEST=0
 while [ -n "$1" ]; do
        case "$1" in
                -i) export INTERACTIVE=1;;
-               -d) export DELAY="$2"; shift;;
                -v) export VERBOSE="$(($VERBOSE + 1))";;
                -q) export VERBOSE="$(($VERBOSE - 1))";;
                -n) export SAVE_CONFIG=0;;
                -c) export SAVE_OVERLAY=1;;
+               -p) export SAVE_PARTITIONS=0;;
+               -u) export SKIP_UNCHANGED=1;;
                -b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;
                -r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;
-               -l|--list-backup) export CONF_BACKUP_LIST=1; break;;
+               -l|--list-backup) export CONF_BACKUP_LIST=1;;
                -f) export CONF_IMAGE="$2"; shift;;
                -F|--force) export FORCE=1;;
                -T|--test) export TEST=1;;
                -h|--help) export HELP=1; break;;
                -*)
-                       echo "Invalid option: $1"
+                       echo "Invalid option: $1" >&2
                        exit 1
                ;;
                *) break;;
@@ -48,20 +49,20 @@ done
 export CONFFILES=/tmp/sysupgrade.conffiles
 export CONF_TAR=/tmp/sysupgrade.tgz
 
-export ARGV="$*"
-export ARGC="$#"
+IMAGE="$1"
 
-[ -z "$ARGV" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
+[ -z "$IMAGE" -a -z "$NEED_IMAGE" -a $CONF_BACKUP_LIST -eq 0 -o $HELP -gt 0 ] && {
        cat <<EOF
 Usage: $0 [<upgrade-option>...] <image file or URL>
-       $0 [-q] [-i] <backup-command> <file>
+       $0 [-q] [-i] [-c] [-u] <backup-command> <file>
 
 upgrade-option:
-       -d <delay>   add a delay before rebooting
        -f <config>  restore configuration from .tar.gz (file or url)
        -i           interactive mode
        -c           attempt to preserve all changed files in /etc/
+       -u           skip from backup files that are equal to those in /rom
        -n           do not save configuration over reflash
+       -p           do not attempt to restore the partition table after flash.
        -T | --test
                     Verify image and config .tar.gz but do not actually flash.
        -F | --force
@@ -87,7 +88,7 @@ EOF
        exit 1
 }
 
-[ -n "$ARGV" -a -n "$NEED_IMAGE" ] && {
+[ -n "$IMAGE" -a -n "$NEED_IMAGE" ] && {
        cat <<-EOF
                -b|--create-backup and -r|--restore-backup do not perform a firmware upgrade.
                Do not specify both -b|-r and a firmware image.
@@ -98,48 +99,76 @@ EOF
 # prevent messages from clobbering the tarball when using stdout
 [ "$CONF_BACKUP" = "-" ] && export VERBOSE=0
 
-add_uci_conffiles() {
+
+list_conffiles() {
+       awk '
+               BEGIN { conffiles = 0 }
+               /^Conffiles:/ { conffiles = 1; next }
+               !/^ / { conffiles = 0; next }
+               conffiles == 1 { print }
+       ' /usr/lib/opkg/status
+}
+
+list_changed_conffiles() {
+       # Cannot handle spaces in filenames - but opkg cannot either...
+       list_conffiles | while read file csum; do
+               [ -r "$file" ] || continue
+
+               echo "${csum}  ${file}" | sha256sum -sc - || echo "$file"
+       done
+}
+
+add_conffiles() {
        local file="$1"
        ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
                /etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
-               -type f -o -type l 2>/dev/null;
-         opkg list-changed-conffiles ) | sort -u > "$file"
+               \( -type f -o -type l \) $find_filter 2>/dev/null;
+         list_changed_conffiles ) | sort -u > "$file"
        return 0
 }
 
 add_overlayfiles() {
        local file="$1"
-       if [ -d /overlay/upper ]; then
-               local overlaydir="/overlay/upper"
-       else
-               local overlaydir="/overlay"
-       fi
-       find $overlaydir/etc/ -type f -o -type l | sed \
-               -e 's,^/overlay\/upper/,/,' \
-               -e 's,^/overlay/,/,' \
-               -e '\,/META_[a-zA-Z0-9]*$,d' \
-               -e '\,/functions.sh$,d' \
+       ( cd /overlay/upper/; find ./etc \( -type f -o -type l \) $find_filter | sed \
+               -e 's,^\.,,' \
+               -e '\,^/etc/board.json$,d' \
                -e '\,/[^/]*-opkg$,d' \
-       > "$file"
+               -e '\,^/etc/urandom.seed$,d' \
+       )> "$file"
        return 0
 }
 
 # hooks
-sysupgrade_image_check="platform_check_image"
-[ $SAVE_OVERLAY = 0 -o ! -d /overlay/etc ] && \
-       sysupgrade_init_conffiles="add_uci_conffiles" || \
+sysupgrade_image_check="fwtool_check_signature fwtool_check_image platform_check_image"
+
+if [ $SAVE_OVERLAY = 1 ]; then
+       [ ! -d /overlay/upper/etc ] && {
+               echo "Cannot find '/overlay/upper/etc', required for '-c'" >&2
+               exit 1
+       }
        sysupgrade_init_conffiles="add_overlayfiles"
+else
+       sysupgrade_init_conffiles="add_conffiles"
+fi
 
-include /lib/upgrade
+find_filter=""
+if [ $SKIP_UNCHANGED = 1 ]; then
+       [ ! -d /rom/ ] && {
+               echo "'/rom/' is required by '-u'"
+               exit 1
+       }
+       find_filter='( ( -exec test -e /rom/{} ; -exec cmp -s /{} /rom/{} ; ) -o -print )'
+fi
 
-[ "$1" = "nand" ] && nand_upgrade_stage2 $@
+include /lib/upgrade
 
 do_save_conffiles() {
-       local conf_tar="${1:-$CONF_TAR}"
+       local conf_tar="$1"
 
        [ -z "$(rootfs_type)" ] && {
-               echo "Cannot save config while running from ramdisk."
+               echo "Cannot save config while running from ramdisk." >&2
                ask_bool 0 "Abort" && exit
+               rm -f "$conf_tar"
                return 0
        }
        run_hooks "$CONFFILES" $sysupgrade_init_conffiles
@@ -148,12 +177,17 @@ do_save_conffiles() {
        v "Saving config files..."
        [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
        tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
+       if [ "$?" -ne 0 ]; then
+               echo "Failed to create the configuration backup."
+               rm -f "$conf_tar"
+               exit 1
+       fi
 
        rm -f "$CONFFILES"
 }
 
 if [ $CONF_BACKUP_LIST -eq 1 ]; then
-       add_uci_conffiles "$CONFFILES"
+       run_hooks "$CONFFILES" $sysupgrade_init_conffiles
        cat "$CONFFILES"
        rm -f "$CONFFILES"
        exit 0
@@ -166,7 +200,7 @@ fi
 
 if [ -n "$CONF_RESTORE" ]; then
        if [ "$CONF_RESTORE" != "-" ] && [ ! -f "$CONF_RESTORE" ]; then
-               echo "Backup archive '$CONF_RESTORE' not found."
+               echo "Backup archive '$CONF_RESTORE' not found." >&2
                exit 1
        fi
 
@@ -176,17 +210,43 @@ if [ -n "$CONF_RESTORE" ]; then
 fi
 
 type platform_check_image >/dev/null 2>/dev/null || {
-       echo "Firmware upgrade is not implemented for this platform."
+       echo "Firmware upgrade is not implemented for this platform." >&2
        exit 1
 }
 
+case "$IMAGE" in
+       http://*|\
+       https://*)
+               wget -O/tmp/sysupgrade.img "$IMAGE"
+               IMAGE=/tmp/sysupgrade.img
+               ;;
+esac
+
+IMAGE="$(readlink -f "$IMAGE")"
+
+case "$IMAGE" in
+       '')
+               echo "Image file not found." >&2
+               exit 1
+               ;;
+       /tmp/*) ;;
+       *)
+               v "Image not in /tmp, copying..."
+               cp -f "$IMAGE" /tmp/sysupgrade.img
+               IMAGE=/tmp/sysupgrade.img
+               ;;
+esac
+
+export ARGV="$IMAGE"
+export ARGC=1
+
 for check in $sysupgrade_image_check; do
-       ( eval "$check \"\$ARGV\"" ) || {
+       ( $check "$IMAGE" ) || {
                if [ $FORCE -eq 1 ]; then
-                       echo "Image check '$check' failed but --force given - will update anyway!"
+                       echo "Image check '$check' failed but --force given - will update anyway!" >&2
                        break
                else
-                       echo "Image check '$check' failed."
+                       echo "Image check '$check' failed." >&2
                        exit 1
                fi
        }
@@ -197,16 +257,17 @@ if [ -n "$CONF_IMAGE" ]; then
                # .gz files
                1f8b) ;;
                *)
-                       echo "Invalid config file. Please use only .tar.gz files"
+                       echo "Invalid config file. Please use only .tar.gz files" >&2
                        exit 1
                ;;
        esac
        get_image "$CONF_IMAGE" "cat" > "$CONF_TAR"
        export SAVE_CONFIG=1
 elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
-       [ $TEST -eq 1 ] || do_save_conffiles
+       [ $TEST -eq 1 ] || do_save_conffiles "$CONF_TAR"
        export SAVE_CONFIG=1
 else
+       [ $TEST -eq 1 ] || rm -f "$CONF_TAR"
        export SAVE_CONFIG=0
 fi
 
@@ -214,28 +275,24 @@ if [ $TEST -eq 1 ]; then
        exit 0
 fi
 
-run_hooks "" $sysupgrade_pre_upgrade
-
-# Some platforms/devices may want different sysupgrade process, e.g. without
-# killing processes yet or calling ubus system upgrade method.
-# This is needed e.g. on NAND devices where we just want to trigger stage1 at
-# this point.
-if type 'platform_pre_upgrade' >/dev/null 2>/dev/null; then
-       platform_pre_upgrade "$ARGV"
+if [ $SAVE_PARTITIONS -eq 0 ]; then
+       touch /tmp/sysupgrade.always.overwrite.bootdisk.partmap
+else
+       rm -f /tmp/sysupgrade.always.overwrite.bootdisk.partmap
 fi
 
-ubus call system upgrade
-touch /tmp/sysupgrade
+install_bin /sbin/upgraded
+v "Commencing upgrade. Closing all shell sessions."
 
-if [ ! -f /tmp/failsafe ] ; then
-       kill_remaining TERM
-       sleep 3
-       kill_remaining KILL
-fi
+COMMAND='. /lib/functions.sh; include /lib/upgrade; do_upgrade_stage2'
 
-if [ -n "$(rootfs_type)" ]; then
-       v "Switching to ramdisk..."
-       run_ramfs '. /lib/functions.sh; include /lib/upgrade; do_upgrade'
+if [ -n "$FAILSAFE" ]; then
+       printf '%s\x00%s\x00%s' "$RAM_ROOT" "$IMAGE" "$COMMAND" >/tmp/sysupgrade
+       lock -u /tmp/.failsafe
 else
-       do_upgrade
+       ubus call system sysupgrade "{
+               \"prefix\": $(json_string "$RAM_ROOT"),
+               \"path\": $(json_string "$IMAGE"),
+               \"command\": $(json_string "$COMMAND")
+       }"
 fi